/*****************************************************************************/
//    ArrayBindEnv.h
/*****************************************************************************/

#ifndef _ArrayBindEnv_H_
#define _ArrayBindEnv_H_

#include "Term.h"
#include "BindEnv.h"

/*****************************************************************************/

class corArrayBindEnv: public corBindEnv {
    friend class corBindEnv;
    friend class corVersionedBindEnv;

    corTerm* bindarray;
    corArrayBindEnv();

public:
    corArrayBindEnv(int size, int incr=-1);

#ifdef NOBINDENVHACK
    virtual inline corTerm lookup(Variable var) const
        {return (bindarray[var]);}
    virtual inline int  bind(Variable var, corTerm binding)
        {bindarray[var]=binding; return 1;}
#endif

    virtual void resize(int newsize);    // Aborts
    virtual int all_free();
    virtual corBindEnv *make_version();    // returns a new copy of the bindenv
    virtual corBindEnv *make_version_and_swap();
    virtual corBindEnv *copy_shell();
    virtual void restore(corBindEnv *env);
    virtual ~corArrayBindEnv();    
};

/*****************************************************************************/

#endif _ArrayBindEnv_H_

