/*****************************************************************************/
//    Execute.h
/*****************************************************************************/

#ifndef _Execute_H_
#define _Execute_H_

#include <stdio.h>

#include "ArgList.h"
#include "SymbolArg.h"
#include "RelationMisc.h"

/*****************************************************************************/

class corQFModuleData;
class corStorageRelation;
class corTable;
class corTupleIterator;
class corModuleInfo;
class corParserStruct;
class corBindEnv;
class corSccInfo;

/*****************************************************************************/

extern corModuleInfo* corCurrModuleInfo;

extern corArgList* corMagicArgs;
extern corBindEnv* corMagicBindEnv;
extern corStorageRelation* corMagicRelation;

/*****************************************************************************/

#define DISPLAY_RULES(X) ((corexEnv->GlobalRelationOptions | (X)->rel_options) &  \
               REL_DISPLAY_INSERTIONS)

/*****************************************************************************/

void corcleanup_do_query(corQFModuleData *md, corStorageRelation *magic,
    corTable *table_copy);

corStorageRelation *cordo_query(corQFModuleData *md, corStorageRelation *magic,
    int old_magic_relation, corTupleIterator *iterator);

corStorageRelation *corfind_local_relation(Name name, int arity);

int corexecute_single_rule(corParserStruct &corparserStruct);

void corPrintSccRecursiveRules(corSccInfo* scc, int start, FILE *outf);
void corPrintSccNonRecursiveRules(corSccInfo* scc, FILE *outf);

/*****************************************************************************/

#endif _Execute_H_

