/*****************************************************************************/
//    GArrayBindEnv.h
/*****************************************************************************/

#ifndef _GArrayBindEnv_H_
#define _GArrayBindEnv_H_

#include "BindEnv.h"

#include "TermGArray.h"

/*****************************************************************************/

class corGArrayBindEnv: public corBindEnv {
    friend class corBindEnv;

    corTerm_garray  *bindarray;
    corGArrayBindEnv();

public:
    corGArrayBindEnv(int size, int incr = 128);

#ifdef NOBINDENVHACK
    virtual inline corTerm lookup(Variable var) const /* HACK */
    {
        return ((*bindarray)[var]);
    }
    virtual inline int  bind(Variable var, corTerm binding) /* HACK */
    {
        (*bindarray)[var]=binding; return 1;
    }
#endif
    virtual void resize(int newsize)
    {
        bindarray->resize(newsize);
        _limit = newsize;
    }

    virtual int all_free();
    virtual corBindEnv *make_version();  // returns a copy of the bindenv
    virtual corBindEnv *make_version_and_swap();
    virtual corBindEnv *copy_shell();
    virtual void restore(corBindEnv *env);
    virtual ~corGArrayBindEnv();    
};

/*****************************************************************************/

#endif _GArrayBindEnv_H_

