/*****************************************************************************/
//    GoalNode.h
/*****************************************************************************/

#ifndef _GoalNode_H_
#define _GoalNode_H_

#include "Tuple.h"
//#include "ContextNode.h"
//#include "StorageRelation.h"
#include "ArgList.h"

/*****************************************************************************/

class corContextNode;
class corStorageRelation;

/*****************************************************************************/

class corGoalNode : public corTuple {
public:
    int mark;
    corGoalNode *parent_goal;
    corContextNode *c_node;
    corStorageRelation *owner_rel;
    // the above fields represent the semantics of goal nodes in the set

    int negated;
    // used to check if program has cyclic negation/aggregation 

    corGoalNode *parent_in_set;
    int rank_in_set;
    // the above two fields are for tarjan's union-find algorithm

    corGoalNode(corStorageRelation *rel, int neg = 0);
    corGoalNode(int arity, corStorageRelation *rel, int neg = 0);
    corGoalNode(corArgList *arglist, corBindEnv *env, corStorageRelation *rel, int neg = 0);
    corGoalNode(corArgList&a, corStorageRelation *rel, int neg = 0);
    corGoalNode(corArgList *arglist, corStorageRelation *rel, int neg = 0);

    ~corGoalNode() { 
#        ifdef DEBUG
            corC_DeleteTupleCount++;
            corC_DeleteTupleSize += sizeof(corGoalNode);
#        endif
    }

    void set_defaults(corStorageRelation *rel, int neg);

    inline void create_goalnode_info(corGoalNode *par) { parent_goal = par; } 

    corGoalNode *find_canonical_elem();
    corContextNode *find_context_node();
    corGoalNode *link_goals(corGoalNode *g);

    inline int is_marked()        { return mark; }
    inline void mark_goal()        { mark = 1; }

    int is_magic_goal();
    void print_all(FILE *file);
    corStorageRelation *find_done_relation();
};

/*****************************************************************************/

#endif _GoalNode_H_

