/*****************************************************************************/
//    PersistentIndex.h
/*****************************************************************************/

#ifndef _PersistentIndex_H_
#define _PersistentIndex_H_

#ifdef WITH_PERSISTENCE

#include "GenericIndex.h"

/*****************************************************************************/

#define Scanning_Persistent 1

#define COR_PERS_INDEX 2

class corPersistentRel;

class corPersistentIndexSet;

/*****************************************************************************/

class corPersistentIndex : public corGenericIndex {
    friend corPersistentIndexSet;
protected:
    inline corPersistentRel *p_rel()    { return (corPersistentRel *)relation; }
public:
    int chosen_index;

    corPersistentIndex(corPersistentRel* , corBitVector *);

    virtual void initialize_iterator(corTupleIterator&) {};
    virtual corTuple *get_next_tuple(corTupleIterator&);
    virtual corBindEnv *get_next(corTupleIterator&);
    virtual int index_type()        { return COR_PERS_INDEX; }
    virtual int is_subsumed(corTuple *tuple) { return 0; }
    
    virtual void insert_tuple( corTuple *tuple ) {};
    virtual void free_all_entries() {};
    virtual void move_all_entries(corGenericIndex *ind) {};
    virtual void reset_index() {};
};

/*****************************************************************************/

#endif WITH_PERSISTENCE

#endif _PersistentIndex_H_

