//**************************************************************************
//    RuleInfo.h
//**************************************************************************

#ifndef _RuleInfo_H_
#define _RuleInfo_H_

#include <stdio.h>

#include "Arg.h"
#include "Profile.h"
//#include "Relation.h"
#include "ArrayBindEnv.h"

//**************************************************************************

class corRelation;
class corClause;

//**************************************************************************

class corRuleInfo { 
public :
    corArgList    *arg_list;
    int        *relations;
    int        *offsets;
    int         num_literals;
    int         num_vars;
    corProfileInfo pInfo;
    corClause     *rule;
    corRelation  **headrel_ptr;

    corRuleInfo(corClause *);

   ~corRuleInfo();
}; 

//**************************************************************************

#define FORWARD 1
#define BACKWARD 0

// Define a couple of macros to avoid messy code within the function.

#define _PROFILE(X,Y,Z) \
   { \
     if ((corexEnv->profile_sn)) {\
       pinfo->print(corexEnv->profile_file,"SNR",Y,Z);\
       corAddProfileInfo(pinfo, &X);\
       pinfo->reset();\
     }\
     else if ((corexEnv->profile_scc) || (corexEnv->profile_module)) { \
         corAddProfileInfo(pinfo, &X);\
             pinfo->reset(); \
          } \
   }

#define NEGATED(index) (rInfo->relations[index] < 0)

extern int do_rule(void *, corRuleInfo *, int, int, ...);

//**************************************************************************

extern corArrayBindEnv corUnusedEnv;

//**************************************************************************

#endif _RuleInfo_H_

