
#include <assert.h>

inline LogHandler::LogHandler(ostream* _pos, int _dispLoc, int _delete_pos)
{
    pos = _pos;
    if( !pos )
      enabled = 0;
    else
      enabled = 1;
    dispLoc = _dispLoc;
    delete_pos = _delete_pos;
}


inline LogHandler::~LogHandler()
{
    if( delete_pos )
      delete pos;
    pos = NULL;			// safty
}

inline void LogHandler::SetStream(ostream* _pos, int _delete_pos)
{
    if( delete_pos )
      delete pos;
    pos = _pos;
    delete_pos = _delete_pos;
    if( pos )
      enabled = 1;
    else
      enabled = 0;
}


inline void LogHandler::Disable()
{
    enabled = 0;
}


inline void LogHandler::Enable()
{
    enabled = 1;
}


inline ostream& LogHandler::OutStream()
{
    assert(enabled);
    return *pos;
}


inline int LogHandler::IsEnabled() const
{
    return enabled;
}


inline int LogHandler::ShowLocation() const
{
    return dispLoc;
}

