#include <stdlib.h>


inline String::Rep* String::Rep::AddReference()
{
    ref_count++;
    return this;
}


inline int String::Rep::DeleteReference()
{
    ref_count--;
    return ref_count;
}



//---------------------------------------------------------------------------


inline String::String()
{
    rep = new Rep();
}


inline String::String(const String& other)
{
    rep = other.rep->AddReference();
}


inline String::String(const char* newStr)
{
    rep = new Rep(newStr);
}


inline String::String(char** strpp)
{
    rep = new Rep(strpp);
}


inline String::~String()
{
    DeleteRep();
}


inline void String::UniqueRep()
{
    if( rep->ref_count > 1 ) {
	Rep* trep = new Rep(*rep);
	DeleteRep();
	rep = trep;
    }
}


inline void String::DeleteRep()
{
    if( rep->DeleteReference() == 0 )
      delete rep;
}


inline int String::Length() const
{
    return strlen(rep->str);
}


inline String& String::operator +=( const String& other )
{
    return this->Concat( other ); 
}


inline String String::operator +( const String& other ) const
{
    String result(*this);
    result.Concat( other );
    return result; 
}


inline int String::operator ==( const String& other ) const
{
    return( strcmp( rep->str, other.rep->str ) == 0 );
}


inline int String::operator !=( const String& other ) const
{
    return( strcmp( rep->str, other.rep->str ) != 0 ); 
}


inline int String::operator >=( const String& other ) const
{
    return( strcmp( rep->str, other.rep->str ) >= 0 ); 
}


inline int String::operator <=( const String& other ) const
{
    return( strcmp( rep->str, other.rep->str ) <= 0 ); 
}


inline int String::operator >( const String& other ) const
{
    return( strcmp( rep->str, other.rep->str ) > 0 ); 
}


inline int String::operator <( const String& other ) const
{
    return( strcmp( rep->str, other.rep->str ) < 0 ); 
}


inline String::operator const char*() const
{
    return rep->str;
}


inline String::operator long() const
{
    return atol(rep->str);
}


inline String::operator double() const
{
    return atof(rep->str);
}


