/*****************************************************************************/
//	ArgList.h
/*****************************************************************************/

#ifndef _ArgList_H_
#define _ArgList_H_

#include "CArg.h"
#include "VarArg.h"

/*****************************************************************************/

class corBindEnv;

/*****************************************************************************/

class corArgList {
	int numArgs;		// number of arguments in ArgList
	int argsSize;		// actual size of array 'args'
	corCArg *args;		// array of ArgPtrs
public:
	corArgList(int size);
	corArgList(const corArgList &);
	corArgList();
	~corArgList();

	void operator=(const corArgList&);
	void set_count(int size);
	int count() const	{ return numArgs; }
	int arity() const	{ return numArgs; }

	corCArg& operator [] (int i) const {
		return args[i];
	}

	const corCArg& arg(int i) const {
		return args[i];
	}

	// Returns true if all the arguments are NumArgs or Symbols
	int isConstant();

	void print_dump(corBindEnv *context, FILE *file) const;
	void print(corBindEnv *context, FILE *file) const;
	void print(corBindEnv *context, FILE *file, char *fmt_str) const;

	void printon(FILE *file) const { print((corBindEnv*)0, file); }
	void sprint(char *str, int *pos, corBindEnv *context = NULL) const;

	corVarLink *var_list(corVarLink* rest);
	Variable max_vars();

	HashVal hash( corBitVector& bv, corBindEnv* env = NULL );
	HashVal hash( corBindEnv* env = NULL );
};

// ; phase III. type info: ArgList ARGLIST, CArg* ARG
#define FOR_EACH_ARG(ARG, ARGLIST)	\
{ \
        register corCArg *ARG;       \
	int __num_for_each_arg_coral__ = (ARGLIST).count(); \
	int __i_for_each_arg_coral__ = 0;       \
        for (; (-- __num_for_each_arg_coral__) >= 0;) { \
		ARG = ( &((ARGLIST)[__i_for_each_arg_coral__++]));

#define END_EACH_ARG \
	} \
}

/*****************************************************************************/

#endif _ArgList_H_

