#include "CArg.h"
#include "Globals.h"

static long print_width = -1;
static long print_precision = -1;
static char print_double_format = 'g';
static char print_int_format = 'd';

corCArg::corCArg(void) 
{
 init();
}

corCArg::corCArg(corArg* arg) 
{ 
 double_arg = 0;
 my_arg_kind =OTHER_ARG; 
 other=arg;
//  if (arg==0) CORAL_error(COR_FATAL_ERROR, "","CArg(arg 0)");
}

corCArg::corCArg(int n) {
  double_arg = 0;
  my_arg_kind = INT_ARG;
  int_arg =n;
 };

corCArg::corCArg(double d)
{
 my_arg_kind = DOUBLE_ARG;
 double_arg = d;
};

corCArg::corCArg(const corCArg & a)
{
 my_arg_kind = a.my_arg_kind;
 double_arg = a.double_arg;
}

void corCArg::init(){
  double_arg = 0;
  other = NULL;
  my_arg_kind = EMPTY_ARG ;
 };

corCArg& corCArg::operator= (const corCArg& a)
{
 double_arg = a.double_arg;		// sharing pointers
 my_arg_kind = a.my_arg_kind;
 return *this;
}

corCArg& corCArg::operator= (int i) {
  my_arg_kind = INT_ARG; 
  int_arg =i; return *this;
 };

corCArg& corCArg::operator= ( double d){
  my_arg_kind = DOUBLE_ARG;
  double_arg = d; return *this;
 };

corCArg& corCArg::operator= (corArg * p) {
  my_arg_kind = OTHER_ARG;
  other = p; 
//  if (p==0)    CORAL_error(COR_FATAL_ERROR, "","CArg(arg 0)");
  return *this;
 };

  int corCArg::operator ==(const corCArg& c) const{
    return IsPtrEqual(c);	// IsPtrEqual is a misnomor. it compares
				// number correctly.
   };

  // if a is number, warning!
  int corCArg::operator ==(corArg* a) const {
    if (a==NULL) 
      return IsEmpty();
    else
      return (my_arg_kind == OTHER_ARG) && (other == a);
   };

  // if a is number, warning!
  int corCArg::operator !=(corArg* a) const {
    if (a==NULL) 
      return !IsEmpty();
    else
      return (my_arg_kind == OTHER_ARG) && (other != a);
   };

int corCArg::equals(const corCArg& arg2) const{
  if ((my_arg_kind ==  OTHER_ARG) && (arg2.my_arg_kind == OTHER_ARG))
    return other->equals(arg2.other);
  else if (i_am_num() && arg2.i_am_num())
    return (! compare_num(arg2));
  else 
    return my_arg_kind == arg2.my_arg_kind;
 }

int corCArg::IsPtrEqual(const corCArg& c) const {
    if (my_arg_kind == OTHER_ARG)
      return (other == c.other);
    else if (i_am_num() && c.i_am_num())
      return (! compare_num(c));
    else
      return 0;
   };

int corCArg::IsEmpty() const{
    if (my_arg_kind==OTHER_ARG)
      return (other == NULL);
    else
      return (my_arg_kind==EMPTY_ARG);
   };

// no type checking
int corCArg::compare_num(const corCArg& arg2) const{
  if ((my_arg_kind ==  INT_ARG) && (arg2.my_arg_kind == INT_ARG)) 
    return (arg2.int_arg < int_arg ? 1 : arg2.int_arg == int_arg ? 0 : -1);
  else if ((my_arg_kind ==  DOUBLE_ARG) && (arg2.my_arg_kind == DOUBLE_ARG)) 
    return ( arg2.double_arg < double_arg ? 1 : arg2.double_arg == double_arg ? 0 : -1);
  else if (my_arg_kind == INT_ARG)
    return ( arg2.double_arg < ((double) int_arg) ? 1 : arg2.double_arg == ((double) int_arg) ? 0 : -1);
  else
    return ( ((double)arg2.int_arg) < double_arg ? 1 : ((double)arg2.int_arg) == double_arg ? 0 : -1);
 }

corCArg corCArg::simplify(corBindEnv *context, corTermLink *&renamed_vars,
		    corBindEnv *const_env, corBindEnv *rename_only_env) const
{
 corCArg temp(*this);
 if (my_arg_kind == OTHER_ARG) 
   temp = other->simplify(context, renamed_vars, const_env, 
			  rename_only_env);
 return temp;
};

void corCArg::print(corBindEnv *context, FILE *file) const 
{
 if ((my_arg_kind == OTHER_ARG) && other)
   other->print(context, file);
   else 
     printon(file);
}

void corCArg::print(corBindEnv *context, FILE *file, char *fmt_str) const 
{
 if ((my_arg_kind == OTHER_ARG) && other)
   other->print(context,file,fmt_str);
   else 
     printon(file,fmt_str);
}

void corCArg::sprint(char *str, int *pos, corBindEnv *context) const 
{
 if ((my_arg_kind == OTHER_ARG) && other)
   other->sprint(str,pos,context);
 else if (my_arg_kind == INT_ARG) 
  {sprintf(str + *pos, "%d", int_arg);
   *pos = strlen(str); 
  } else if (my_arg_kind ==DOUBLE_ARG){
    sprintf(str + *pos, "%f", double_arg);
    *pos = strlen(str);
   }
  else 
    CORAL_error(COR_FATAL_ERROR, "","sprint");
}

void corCArg::printon(FILE *file) const 
{
 if ((my_arg_kind == OTHER_ARG) && other)
   other->printon(file);
 else if (i_am_num()) {
        char format[20]; char buffer[100];
	char *fptr = format;

	*fptr++ = '%';
	if (print_width >= 0) {
		sprintf(fptr, "%ld", print_width);
		fptr += strlen(fptr);
	}
	if (print_precision >= 0) {
		sprintf(fptr, ".%ld", print_precision);
		fptr += strlen(fptr);
 	}
	*fptr++ = (my_arg_kind==INT_ARG ? print_int_format :
		print_double_format);
	*fptr = '\0';
	if (my_arg_kind==INT_ARG)
		sprintf(buffer, format, int_arg);
	else
		sprintf(buffer, format, double_arg);
 
	// Kludge to make sure the last char isn't '.'.
	fptr = buffer + strlen(buffer);
	if (fptr[-1] == '.') {
		fptr[0] = '0';
		fptr[1] = 0;
	}
	fputs(buffer, file);
       }
 else 
   CORAL_error(COR_FATAL_ERROR, "","printon1");

}

void corCArg::printon(FILE *file, char *fmt_str) const 
{
 if ((my_arg_kind == OTHER_ARG) && other)
   other->printon(file, fmt_str);
 else if (i_am_num()) {
	char buffer[100];
	if (my_arg_kind==INT_ARG)
		sprintf(buffer, fmt_str, int_arg);
	else
		sprintf(buffer, fmt_str, double_arg);
	
	char *temp = fmt_str;
	
	if (*temp == '\0')
		fprintf(corexEnv->error_file,
			"Incorrect format statement provided to print float value.\n");
	
	while (*temp != '\0') {
		if (my_arg_kind==INT_ARG &&
			(((*temp) == 'd') || ((*temp) == 'D'))) break;
		if (my_arg_kind==DOUBLE_ARG && 
			(*temp == 'f' || *temp == 'g' || *temp == 'G' || *temp == 'e' ||
				*temp == 'E')) break;
		temp++;
	}
	
	// Kludge to make sure the last char isn't '.'.
	char * fptr = buffer + strlen(buffer);
	if (fptr[-1] == '.')
	{
		fptr[0] = '0';
		fptr[1] = 0;
	}
	
	fputs(buffer, file);
       }
 else 
   CORAL_error(COR_FATAL_ERROR, "","printon2");
}

corVarLink* corCArg::var_list(corVarLink* rest) {
    if (my_arg_kind == OTHER_ARG)
      return other->var_list(rest);
    else
      return rest;
   };

Variable corCArg::max_vars() {
    if (my_arg_kind == OTHER_ARG)
      return other->max_vars();
    else
      return 0;
   };

void corCArg::output() const { 
    if (my_arg_kind == OTHER_ARG)
      other->output();
    else
      print((corBindEnv*)0, stderr);
   };

int corCArg::subkind() const{ 
  if (my_arg_kind == OTHER_ARG)
    return other->subkind();
  else
    return 0; 
  };
  
int corCArg::scan_vars(void *data, VarFunc *func) {
    if (my_arg_kind == OTHER_ARG)
      return other->scan_vars(data,func) ;
    else
      return 0;
   };

void corCArg::print_dump(corBindEnv *context, FILE *file) const {
    if (my_arg_kind == OTHER_ARG)
      other->print_dump(context, file);
    else
      print(context,file) ;
   };

HashVal corCArg::hash(corBindEnv *context) const {
    if (my_arg_kind == OTHER_ARG) 
      return other->hash(context);
    else if (my_arg_kind != EMPTY_ARG) 
      return corIntToHash(int_arg);
    else 
      return VarHashValue;
   };
