/*****************************************************************************/
//	FixedArrayArg.C
/*****************************************************************************/

#include "FixedArrayArg.h"

/*****************************************************************************/
void corFixedArrayArg::print(corBindEnv *context, FILE *file) const
{
	fprintf(file, " ARRAY(");
	for(int i=0; i < _size; i++) {
		corarray[i].print(context, file);
		if (i < _size -1) fprintf(file, ",\n\t");
	}
	fprintf(file, ")");
}

/*****************************************************************************/
corFixedArrayArg::corFixedArrayArg(int size1)
{
	_size = size1;
	corarray = new corCArg[_size];
	//for(int i=0; i < _size; i++)
	//	((Arg**)array)[i] = NilSymbol;
}

/*****************************************************************************/
corArrayArg* corFixedArrayArg::make_version()
{
	// WARNING:  be careful about using this function.  It is quite 
	//	inefficient since it copies out the whole array.
	//	Should probably use logical_array instead.

	corArrayArg *new_array = new corFixedArrayArg(_size);
	for (int i=0; i < _size; i++) {
		new_array->bind(i,& lookup(i));
	}
	return new_array;
}

/*****************************************************************************/

