//**************************************************************************
//    SymbolArg.C
//**************************************************************************

#include "SymbolArg.h"

#include "Globals.h"
#include "BuiltinSymbols.h"            // NilSymbol

//**************************************************************************
void corSymbol::print(corBindEnv*, FILE *file) const
{
    if (this == corNilSymbol)
        fputs("[]", file);
    else {
        if (corexEnv->C_use_quotes){
            putc('"',file);
            fputs(str,file);
            putc('"',file);
        } else {
            fputs(str,file);
        }
    }
}

//**************************************************************************
// Same as above but no double quotes (for the "print" command)

void corSymbol::print_nq(corBindEnv*, FILE *file) const
{
    if (this == corNilSymbol)
        fputs("[]", file);
    else {
        fputs(str,file);
    }
}

//**************************************************************************
void corSymbol::print(corBindEnv *env, FILE *file, char *fmt_str) const
{
    char *temp = fmt_str;

    while (*temp != '\0') {
        if (*temp == 's') break;
        temp++;
    }

    if (*temp == '\0') {
        fprintf( corexEnv->error_file,
           "Incorrect format statement provided to print string.\n");
        print(env, file);
    }
    else {
        if (this == corNilSymbol)
            fputs("[]",file);
        else {
            fprintf(file, fmt_str, str);
        }
    }
}

//**************************************************************************
void corSymbol::sprint(char* string, int* pos, corBindEnv *) const
{
    if (this == corNilSymbol) {
        sprintf(string + *pos, "[]");
        *pos += 2 ;
    }
    else {
        sprintf(string + *pos, "%s", str);
        *pos += length();
    }
}

//**************************************************************************
int corSymbol::equals(corArg *arg2)
{
    if (this == (corSymbol *)arg2) return 1;
    if (arg2->kindof() != COR_SYMBOL_CONST)
        return(0);
    if (_hash != ((corSymbol *)arg2)->_hash) 
      return 0;

    return (!memcmp(str, corSymbolString(arg2), _length));
}

//**************************************************************************
