/*****************************************************************************/
//    BuiltinRelation.h
/*****************************************************************************/

#ifndef _BuiltinRelation_H_
#define _BuiltinRelation_H_

#include "Relation.h"

/*****************************************************************************/

class corBuiltinRelation;
class corTupleIterator;

typedef corBindEnv* (*SolveProc)(corBuiltinRelation&, corTupleIterator&);
typedef corTuple* (*UserTupleProc)(corTuple *query);
typedef corRelation* (*UserRelProc)(corTuple  *query);

/*****************************************************************************/
//    Each builtin-relation is associated with a 'solver'
//    function that is invoked when a get_next() occurs it.

class corBuiltinRelation : public corRelation {
public:
    SolveProc solver;

    corBuiltinRelation(int a, Name n, SolveProc solve_proc);
    corBuiltinRelation(char * n, int a, UserRelProc solve_proc);
    corBuiltinRelation(char * n, int a, UserTupleProc solve_proc);

    virtual corBindEnv* get_next(corTupleIterator&);
    virtual void release(corTupleIterator&);
    virtual corTuple* get_next_tuple(corTupleIterator& it) {
        get_next(it);
        return(NULL);
    }

    virtual int insert_tuple(corTuple *tuple);

    virtual int insert_new(corArgList &args, corBindEnv *env,
        corBindEnv *dont_rename_env = NULL, corTuple *parent_goal = NULL,
        int dont_rename =0);

    virtual void print_name(FILE *file);
    virtual int is_printable_builtin() {return 1;}
};

/*****************************************************************************/

#endif _BuiltinRelation_H_

