// *************************************************************************
//    BuiltinSymbols.C
// *************************************************************************

// *************************************************************************

#define DeclareKeyword(x,s) corSymbol* x;
#undef _BuiltinSymbols_H_
#include "BuiltinSymbols.h"
#undef DeclareKeyword


  /*
  void init_builtin_symbols()
  {
  #define DeclareKeyword(x,s) x = EnterSymbol(s);
  #undef _BuiltinSymbols_H_
  #include "BuiltinSymbols.h"
  #undef DeclareKeyword
  }
  */


void corinit_builtin_symbols()
{

 corConsSymbol     = corEnterSymbol("cons"); 
 corListSymbol     = corEnterSymbol("_LIST_"); 
 corNestedSymbol   = corEnterSymbol("__NESTED__"); 
 corNilSymbol      = corEnterSymbol("nil"); 
 corTrueSymbol     = corEnterSymbol("true"); 
 corModuleSymbol   = corEnterSymbol("module"); 
 corExportSymbol   = corEnterSymbol("export"); 
 corQSymbol        = corEnterSymbol("q"); 
 corQuerySymbol    = corEnterSymbol("query"); 
 corDontCareSymbol = corEnterSymbol("_"); 
 corCutSymbol      = corEnterSymbol("cut_"); 

// Arithmetic operations
 corAddOpSymbol    = corEnterSymbol("add_"); 
 corSubOpSymbol    = corEnterSymbol("sub_"); 
 corMulOpSymbol    = corEnterSymbol("mul_"); 
 corDivOpSymbol    = corEnterSymbol("div_"); 
 corIDivOpSymbol   = corEnterSymbol("idiv_"); 
 corEquOpSymbol    = corEnterSymbol("equ_"); 
 corNeqOpSymbol    = corEnterSymbol("neq_"); 
 corLssOpSymbol    = corEnterSymbol("lss_"); 
 corGrtOpSymbol    = corEnterSymbol("grt_"); 
 corLeqOpSymbol    = corEnterSymbol("leq_"); 
 corGeqOpSymbol    = corEnterSymbol("geq_"); 
 corCopyTermSymbol = corEnterSymbol("copy_term"); 

// Head aggregate operators
 corSumOpSymbol   = corEnterSymbol("sum"); 
 corProdOpSymbol  = corEnterSymbol("prod"); 
 corCountOpSymbol = corEnterSymbol("count"); 
 corMinOpSymbol   = corEnterSymbol("min"); 
 corMaxOpSymbol   = corEnterSymbol("max"); 
 corAvgOpSymbol   = corEnterSymbol("avg"); 
 corADstOpSymbol  = corEnterSymbol("avg_distinct"); 
 corSDstOpSymbol  = corEnterSymbol("sum_distinct"); 
 corPDstOpSymbol  = corEnterSymbol("prod_distinct"); 
 corCDstOpSymbol  = corEnterSymbol("count_distinct"); 
 corDstOpSymbol   = corEnterSymbol("distinct"); 

 corAbsOpSymbol   = corEnterSymbol("abs"); 
 corCeilOpSymbol  = corEnterSymbol("ceiling"); 
 corFloorOpSymbol = corEnterSymbol("floor"); 
 corAnyOpSymbol   = corEnterSymbol("any"); 

// bitwise operator builtins
 corLShiftOpSymbol  = corEnterSymbol("lshift_");   //  <<
 corRShiftOpSymbol  = corEnterSymbol("rshift_");   //  >>
 corBitorOpSymbol   = corEnterSymbol("bitor_");    //  bitor
 corBitandOpSymbol  = corEnterSymbol("bitand_");   //  bitand
 corBitnotOpSymbol  = corEnterSymbol("bitnot_");   //  bitnot
 corBitxorOpSymbol  = corEnterSymbol("bitxor_");   //  bitxor
 corCompOpSymbol    = corEnterSymbol("comp_");     //  ~
 corModOpSymbol     = corEnterSymbol("mod_");      //  %

// set manipulation builtins
 corAddElemSymbol     = corEnterSymbol("add_elem"); 
 corAddElemDSymbol    = corEnterSymbol("add_elem_d"); 
 corCallSymbol        = corEnterSymbol("call"); 
 corCreateSetSymbol   = corEnterSymbol("create_set"); 
// MsetOpSymbol    = EnterSymbol("makeset"); 
 corMemberSymbol      = corEnterSymbol("member"); 
 corMemTupleSymbol    = corEnterSymbol("memtuple"); 
 corSubsetSymbol      = corEnterSymbol("subset"); 
 corUnionSumSymbol    = corEnterSymbol("unionsum"); 
 corUnionMaxSymbol    = corEnterSymbol("unionmax"); 
 corUnionSumDSymbol   = corEnterSymbol("unionsum_d"); 
 corUnionMaxDSymbol   = corEnterSymbol("unionmax_d"); 
 corUnivSymbol        = corEnterSymbol("univ"); 
 corInterSymbol       = corEnterSymbol("inter"); 
 corDifferenceSymbol  = corEnterSymbol("difference"); 
 corMakeSetSymbol     = corEnterSymbol("make_set"); 
 corInterDSymbol      = corEnterSymbol("inter_d"); 
 corDifferenceDSymbol = corEnterSymbol("difference_d"); 
 corMakeSetDSymbol    = corEnterSymbol("make_set_d"); 


 corFunctorSymbol  = corEnterSymbol("functor"); 
 corArgSymbol      = corEnterSymbol("arg"); 
 corPowSymbol      = corEnterSymbol("pow"); 


// string manipulation builtins
 corLengthSymbol    = corEnterSymbol("length"); 
 corExtractSymbol   = corEnterSymbol("extract"); 
 corSubstringSymbol = corEnterSymbol("substr");


// User annotations
 corSupplementaryMagicSymbol  = corEnterSymbol("sup_magic");  
 corOrdinaryMagicSymbol       = corEnterSymbol("magic");  
 corNoMagicSymbol             = corEnterSymbol("no_form_of_magic");  
 corSupMagicIndexingSymbol    = corEnterSymbol("sup_magic_indexing");  
 corExistOptSymbol            = corEnterSymbol("existential"); 
 corUseFactoringSymbol        = corEnterSymbol("factoring"); 
 corUseFactorMagicSymbol      = corEnterSymbol("factor_magic"); 
 corUsePipeliningSymbol       = corEnterSymbol("pipelining"); 
 corUseOrdSearchSymbol        = corEnterSymbol("ordered_search"); 
 corSaveModuleSymbol          = corEnterSymbol("save_module");  
 corNoRewritingSymbol         = corEnterSymbol("no_rewriting"); 
 corNoPreProcessingSymbol     = corEnterSymbol("no_preprocessing"); 

 corNestedSccEvalSymbol     = corEnterSymbol("nested_scc_eval");   // added by Ken

 corSingleSccSymbol         = corEnterSymbol("single_scc"); 
 corSingleAnswerSymbol      = corEnterSymbol("single_answer"); 
 corConvertFunctionsSymbol  = corEnterSymbol("convert_functions"); 
 corPredicateSNSymbol       = corEnterSymbol("psn");  

 corMultisetSymbol        = corEnterSymbol("multiset");  
 corCheckSubsumSymbol     = corEnterSymbol("check_subsumption");  
 corAggSelectionSymbol    = corEnterSymbol("aggregate_selection"); 
 corPrioritizeSymbol      = corEnterSymbol("prioritize"); 
 corChoiceSymbol          = corEnterSymbol("choice"); 
 corDiskResidentSymbol    = corEnterSymbol("disk"); 

 corIndexDeltaSymbol      = corEnterSymbol("index_deltas");  
 corReturnUnifySymbol     = corEnterSymbol("return_unify");  
 corEagerEvalSymbol       = corEnterSymbol("lazy_eval"); 
 corMonotonicSymbol       = corEnterSymbol("monotonic"); 
 corMakeIndexSymbol       = corEnterSymbol("make_index"); 
 corAllowedAdornSymbol    = corEnterSymbol("allowed_adornments"); 
 corAllowedIndexSymbol    = corEnterSymbol("allowed_index_args"); 
 corNonGroundFactsSymbol  = corEnterSymbol("non_ground_facts"); 
 corSipReorderSymbol      = corEnterSymbol("sip_reorder"); 
 corEagerIndexingSymbol   = corEnterSymbol("eager_indexing"); 

// Print builtins
 corPrintEmptySymbol    = corEnterSymbol("print_empty"); 
 corPrintBindingSymbol  = corEnterSymbol("print_bindings"); 
 corPrintTupleSymbol    = corEnterSymbol("print_tuple"); 
 corDisplaySymbol       = corEnterSymbol("print"); 
 corPrintfSymbol        = corEnterSymbol("printf"); 
 corScanfSymbol         = corEnterSymbol("scanf"); 
 corPrintModSymbol      = corEnterSymbol("print_module");

// Builtin relations
 corAliasSymbol         = corEnterSymbol("alias_rel"); 
 corAssignSymbol        = corEnterSymbol("assign"); 
 corClearSymbol         = corEnterSymbol("clear"  ); 
 corConsultSymbol       = corEnterSymbol("consult");  
 corCpuTimeSymbol       = corEnterSymbol("cputime"); 
 corDeleteFactSymbol    = corEnterSymbol("delete"); 
 corDisplayTimerSymbol  = corEnterSymbol("display_timer"); 
 corExplainOffSymbol    = corEnterSymbol("explain_off"); 
 corExplainOnSymbol     = corEnterSymbol("explain_on"); 
 corFailSymbol          = corEnterSymbol("fail");  
 corGetSymbol           = corEnterSymbol("get"); 
 corGoalIdOpSymbol      = corEnterSymbol("goal_id");  
 corHelpSymbol          = corEnterSymbol("help"); 
 corHistorySymbol       = corEnterSymbol("history"); 
 corInsertFactSymbol    = corEnterSymbol("insert"); 
 corPipeInSymbol        = corEnterSymbol("pipein");  
 corPipeOutSymbol       = corEnterSymbol("pipeout");  
 corProfileOffSymbol    = corEnterSymbol("profile_off"); 
 corProfileOnSymbol     = corEnterSymbol("profile_on"); 
 corQuitSymbol          = corEnterSymbol("quit");  
 corSetSymbol           = corEnterSymbol("set"  ); 
 corBreakSymbol         = corEnterSymbol("set_break");
 corClearBreakSymbol    = corEnterSymbol("clear_break");
 corShellSymbol         = corEnterSymbol("shell"); 
 corStartTimerSymbol    = corEnterSymbol("reset_timer"); 
 corTraceSymbol         = corEnterSymbol("trace_on"); 
 corUntraceSymbol       = corEnterSymbol("trace_off"); 
 corWriteTableSymbol    = corEnterSymbol("write_table"); 

extern char *corArrayConstructorString;
 corArrayConstructSymbol  = corEnterSymbol(  corArrayConstructorString ); 

// Builtin relations for suspensions and client/server operation
 corAnswerSymbol    = corEnterSymbol("answer");
 corKillSymbol      = corEnterSymbol("kill");
 corListSusSymbol   = corEnterSymbol("list_sus");
 corLoginSymbol     = corEnterSymbol("login");
 corLogoutSymbol    = corEnterSymbol("logout");
 corResumeSymbol    = corEnterSymbol("resume");
 corSocketRelSymbol = corEnterSymbol("socket_rel");
 corSyncSymbol      = corEnterSymbol("sync");
 corUserSymbol      = corEnterSymbol("user");
 corWhoSymbol       = corEnterSymbol("who");
 corWhoamiSymbol    = corEnterSymbol("whoami");
 corYieldSymbol     = corEnterSymbol("yield");

 // Counter Stuff
 corCounterSymbol = corEnterSymbol("c_counter");
 corResetCounterSymbol  = corEnterSymbol("reset_c_counter");

// Builtin relations to deal with multiple workspaces( nee\ databases)
 corCreateDBSymbol      = corEnterSymbol("ws_create"); 
 corDestroyDBSymbol     = corEnterSymbol("ws_destroy"); 
 corCurrentDBSymbol     = corEnterSymbol("ws_current"); 
 corSaveDBSymbol        = corEnterSymbol("ws_save"); 
 corRenameDBSymbol      = corEnterSymbol("ws_rename"); 
 corClearDBSymbol       = corEnterSymbol("ws_clear"); 
 corCopyRelToDBSymbol   = corEnterSymbol("rel_copy"); 
 corAddRelToDBSymbol    = corEnterSymbol("rel_add"); 
 corClearRelSymbol      = corEnterSymbol("rel_clear"); 
 corCloseRelSymbol      = corEnterSymbol("rel_close"); 
 corListRelsInDBSymbol  = corEnterSymbol("list_rels"); 
 corListDBSymbol        = corEnterSymbol("list_ws"); 
 corOpenRelInDBSymbol   = corEnterSymbol("rel_open"); 

// Builtin relations to handle the default execution environment
 corDisplayDefaultsSymbol  = corEnterSymbol("display_defaults"); 
 corResetDefaultsSymbol    = corEnterSymbol("reset_defaults"); 

// Builtin relations to check the type of an arg
 corIsConstantSymbol  = corEnterSymbol("is_constant"); 
 corIsVarSymbol       = corEnterSymbol("is_var"); 
 corIsListSymbol      = corEnterSymbol("is_list"); 
 corIsFunctorSymbol   = corEnterSymbol("is_functor"); 
 corIsStringSymbol    = corEnterSymbol("is_string"); 
 corIsNumSymbol       = corEnterSymbol("is_num"); 
 corIsIntSymbol       = corEnterSymbol("is_int"); 
 corIsLongSymbol      = corEnterSymbol("is_long"); 
 corIsShortSymbol     = corEnterSymbol("is_short"); 
 corIsFloatSymbol     = corEnterSymbol("is_float"); 
 corIsDoubleSymbol    = corEnterSymbol("is_double"); 
}

// *************************************************************************
