/*****************************************************************************/
//    InitBuiltins.C
/*****************************************************************************/

#include "InitBuiltins.h"

#include "Arg.h"
#include "BuiltinSymbols.h"
#include "Globals.h"
#include "DatabaseStruct.h"
#include "ModuleInfo.h"
#include "BindEnv.h"

#include "Operators.h"
#include "BuiltinRelation.h"
#include "BuiltinSetRelation.h"
#include "BuiltinCompareRelation.h"
#include "BuiltinUnaryRelation.h"
#include "BuiltinBinaryRelation.h"
#include "BuiltinTraceRelation.h"
#include "BuiltinDebugRelation.h"
#include "BuiltinIndexRelation.h"
#include "BuiltinFailRelation.h"
#include "BuiltinUserTupleRelation.h"

#ifdef Wei_Change
#include "SocketRelSolver.h"
#endif

/*****************************************************************************/

extern corDatabaseStruct corBuiltinDB;
extern corModuleInfo *corCurrModuleInfo;

extern corBuiltinSetRelation MemberBuiltin;

/*****************************************************************************/

extern corBuiltinUnaryRelation SumBuiltin;
extern corBuiltinUnaryRelation CountBuiltin;
extern corBuiltinUnaryRelation MinBuiltin;
extern corBuiltinUnaryRelation MaxBuiltin;
extern corBuiltinUnaryRelation AvgBuiltin;

extern corBuiltinBinaryRelation AddBuiltin;
extern corBuiltinBinaryRelation SubBuiltin;
extern corBuiltinBinaryRelation MulBuiltin;
extern corBuiltinBinaryRelation DivBuiltin;

extern corBuiltinCompareRelation EquBuiltin;
extern corBuiltinCompareRelation NeqBuiltin;
extern corBuiltinCompareRelation LssBuiltin;
extern corBuiltinCompareRelation GrtBuiltin;
extern corBuiltinCompareRelation LeqBuiltin;
extern corBuiltinCompareRelation GeqBuiltin;

extern corBuiltinTraceRelation TraceBuiltin, UntraceBuiltin;
extern corBuiltinDebugRelation SetBuiltin, ClearBuiltin, AssignBuiltin;
extern corBuiltinRelation DisplayBuiltin, HelpBuiltin, PrintfBuiltin ;
extern corBuiltinRelation StartTimeRelation, DisplayTimeRelation ;
extern corBuiltinRelation ConsultBuiltin;
extern corBuiltinIndexRelation AddIndexBuiltin ;
extern corBuiltinFailRelation  FailBuiltin;

/*****************************************************************************/

corTerm corstatic_terms[3];
corTerm corusable_terms[10];

extern corBindEnv *corGoalIdOp(corBuiltinRelation& goal_id, corTupleIterator& iter);
extern corBindEnv *corHelpSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corConsultSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corTuplePrintSolver(corBuiltinRelation& rel,
                  corTupleIterator& iterator);
extern corBindEnv *corBindingsPrintSolver(corBuiltinRelation& rel,
                  corTupleIterator& iterator);
extern corBindEnv *corPrintfSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corPrintSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corStartTimeSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corEndTimeSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corShellSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corRelDisplay(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corpipeInSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corpipeOutSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corwriteTableSolver(corBuiltinRelation& rel,corTupleIterator& iterator);
extern corBindEnv *coraddIndexSolver2(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *coraddIndexSolver1(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corHistorySolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corAliasSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corDisplayDefaultsSolver(corBuiltinRelation& rel,
                      corTupleIterator& iterator);
extern corBindEnv *corResetDefaultsSolver(corBuiltinRelation& rel,
                    corTupleIterator& iterator);


extern corBindEnv *corCreateDBSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corDestroyDBSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corCurrentDBSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corSaveDBSolver(corBuiltinRelation& rel, corTupleIterator& iterator) ;
extern corBindEnv *corRenameDBSolver(corBuiltinRelation& rel, corTupleIterator& iterator) ;
extern corBindEnv *corClearDBSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corListDBSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corOpenRelSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corCloseRelSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corClearRelSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corCopyRelSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corAddRelSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corInsertFactSolver(corBuiltinRelation& rel,corTupleIterator& iterator);
extern corBindEnv *corDeleteFactSolver(corBuiltinRelation& rel,corTupleIterator& iterator);
//extern BindEnv *ListRelationSolver(BuiltinRelation& rel,TupleIterator& iterator);

extern corTuple * corLengthSolver(corTuple *query);
extern corTuple * corExtractSolver(corTuple *query);
extern corTuple * corSubstringSolver(corTuple *query);

extern corTuple   *corPowSolver(corTuple* in);
extern corTuple   *corAbsSolver(corTuple* in);
extern corTuple   *corCeilSolver(corTuple* in);
extern corTuple   *corFloorSolver(corTuple* in);
extern corTuple   *corCputimeSolver(corTuple* in);
extern corTuple   *corCreateSetSolver(corTuple* in);
extern corTuple   *corAddElemSolver(corTuple* in);
extern corTuple   *corAddElemDSolver(corTuple* in);

extern char *corArrayDestructorString;
extern char *corArrayConstructorString;
extern char *corLogicalArrayConstructorString;
extern char *corArrayLookupString;
extern char *corArrayBindString, *corLogicalArrayBindString;
extern corBindEnv *corArraySolver(corBuiltinRelation& rel,
              corTupleIterator& iterator);
extern corBindEnv *corArrayDestructSolver(corBuiltinRelation& rel,
              corTupleIterator& iterator);
extern corBindEnv *corArrayLookupSolver(corBuiltinRelation& rel,
              corTupleIterator& iterator);
extern corBindEnv *corArrayBindSolver(corBuiltinRelation& rel,
              corTupleIterator& iterator);
extern corBindEnv *corLogicalArrayBindSolver(corBuiltinRelation& rel,
                       corTupleIterator& iterator);

extern corBindEnv *ArgTypeSolver(corBuiltinRelation&, corTupleIterator& iterator);

extern corBindEnv *corBreakSolver(corBuiltinRelation& rel, corTupleIterator& iterator);


extern corBindEnv *corAnswerSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corKillSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corListSusSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corLoginSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corLogoutSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corResumeSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corSyncSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corUserSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corWhoSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corWhoamiSolver(corBuiltinRelation& rel, corTupleIterator& iterator);
extern corBindEnv *corYieldSolver(corBuiltinRelation& rel, corTupleIterator& iterator);

extern corBindEnv *corPrintModuleSolver(corBuiltinRelation& rel, corTupleIterator& iter);

/*****************************************************************************/
void corInsertBuiltin(Name n, corRelation *r)
{
    if (!corBuiltinDB.RelationTable)
        corBuiltinDB.RelationTable = corAllocTab(COR_RELATION_TABLE_INCR, NULL);
    corInsert(corBuiltinDB.RelationTable, n, r);
}

/*****************************************************************************/
void corinitBuiltins()
{
    corBuiltinRelation *temp;
#ifdef Wei_Change
    temp = new corBuiltinRelation(-1, corSocketRelSymbol, SocketRelSolver);
#endif
    temp = new corBuiltinRelation(-1, corWhoSymbol, corWhoSolver);
    temp = new corBuiltinRelation(-1, corWhoamiSymbol, corWhoamiSolver);
    temp = new corBuiltinRelation(-1, corLoginSymbol, corLoginSolver);
    temp = new corBuiltinRelation(-1, corLogoutSymbol, corLogoutSolver);
    temp = new corBuiltinRelation(-1, corAnswerSymbol, corAnswerSolver);
    temp = new corBuiltinRelation(-1, corUserSymbol, corUserSolver);
    temp = new corBuiltinRelation(-1, corYieldSymbol, corYieldSolver);

    temp = new corBuiltinRelation(-1, corListSusSymbol, corListSusSolver);
    // list_suspension, not sure -1 yet. WX

    temp = new corBuiltinRelation(-1, corResumeSymbol, corResumeSolver);
    // resume suspension, not sure -1 yet. WX

    temp = new corBuiltinRelation(-1, corSyncSymbol, corSyncSolver);
    temp = new corBuiltinRelation(-1, corKillSymbol, corKillSolver);

    temp = new corBuiltinRelation(-1, corBreakSymbol, corBreakSolver);
    temp = new corBuiltinRelation(-1, corClearBreakSymbol, corClearBreakSolver);
    temp = new corBuiltinRelation(-1, corPrintModSymbol, corPrintModuleSolver);
    
    temp = new corBuiltinSetRelation(-1, corMemTupleSymbol, corMemTupleSolver);
    temp = new corBuiltinSetRelation(-1, corMemberSymbol, corMemberSolver); 
    temp = new corBuiltinSetRelation(1, corCallSymbol, corCallSolver);
    temp = new corBuiltinRelation(2, corUnivSymbol, corUnivSolver);
    temp = new corBuiltinSetRelation(2, corSubsetSymbol, corSubsetSolver);
    temp = new corBuiltinSetRelation(3, corUnionSumSymbol, corUnionSolver);
    temp = new corBuiltinSetRelation(2, corUnionSumDSymbol, corUnionDSolver);
    temp = new corBuiltinSetRelation(3, corUnionMaxSymbol,corMultiUnionSolver);
    temp = new corBuiltinSetRelation(2, corUnionMaxDSymbol,corMultiUnionDSolver);
    temp = new corBuiltinSetRelation(3, corInterSymbol, corIntersectionSolver);
    temp = new corBuiltinSetRelation(2, corInterDSymbol, corIntersectionDSolver);
    temp = new corBuiltinSetRelation(3, corDifferenceSymbol, corDiffSolver);
    temp = new corBuiltinSetRelation(2, corDifferenceDSymbol, corDiffDSolver);
    temp = new corBuiltinSetRelation(2, corMakeSetSymbol, corMakeSetSolver);
    temp = new corBuiltinSetRelation(1, corMakeSetDSymbol, corMakeSetDSolver);
    temp = new corBuiltinUserTupleRelation(1, corCreateSetSymbol, corCreateSetSolver);
    temp = new corBuiltinUserTupleRelation(3, corAddElemSymbol, corAddElemSolver);
    temp = new corBuiltinUserTupleRelation(2, corAddElemDSymbol, corAddElemDSolver);
    temp = new corBuiltinUserTupleRelation(2, corAbsOpSymbol, corAbsSolver);
    temp = new corBuiltinUserTupleRelation(2, corCeilOpSymbol, corCeilSolver);
    temp = new corBuiltinUserTupleRelation(2, corFloorOpSymbol, corFloorSolver);

    temp = new corBuiltinUserTupleRelation(3, corFunctorSymbol, corFuncOp);
    temp = new corBuiltinUserTupleRelation(3, corArgSymbol, ArgOp);
    temp = new corBuiltinUserTupleRelation(3, corPowSymbol, corPowSolver);

    temp = new corBuiltinUserTupleRelation(2, corLengthSymbol, corLengthSolver);
    temp = new corBuiltinUserTupleRelation(3, corExtractSymbol, corExtractSolver);
    temp = new corBuiltinUserTupleRelation(3, corSubstringSymbol, corSubstringSolver);

    temp = new corBuiltinBinaryRelation(3, corLShiftOpSymbol, corLShiftOp);
    temp = new corBuiltinBinaryRelation(3, corRShiftOpSymbol, corRShiftOp);
    temp = new corBuiltinBinaryRelation(3, corBitandOpSymbol, corBitandOp);
    temp = new corBuiltinBinaryRelation(3, corBitorOpSymbol, corBitorOp);
    temp = new corBuiltinBinaryRelation(3, corBitxorOpSymbol, corBitxorOp);
    temp = new corBuiltinBinaryRelation(3, corModOpSymbol, corModOp);

    temp = new corBuiltinBinaryRelation(3, corAddOpSymbol, corAddOp);
    temp = new corBuiltinBinaryRelation(3, corSubOpSymbol, corSubOp);
    temp = new corBuiltinBinaryRelation(3, corMulOpSymbol, corMulOp);
    temp = new corBuiltinBinaryRelation(3, corDivOpSymbol, corDivOp);
    
    temp = new corBuiltinUnaryRelation(2, corSumOpSymbol, corSumOp);
    temp = new corBuiltinUnaryRelation(2, corProdOpSymbol, corProdOp);
    temp = new corBuiltinUnaryRelation(2, corCountOpSymbol, corCountOp);
    temp = new corBuiltinUnaryRelation(2, corMaxOpSymbol, corMaxOp);
    temp = new corBuiltinUnaryRelation(2, corMinOpSymbol, corMinOp);
    temp = new corBuiltinUnaryRelation(2, corAvgOpSymbol, corAvgOp);

    temp = new corBuiltinCompareRelation(2, corEquOpSymbol, corEquOp);
    temp = new corBuiltinCompareRelation(2, corNeqOpSymbol, corNeqOp);
    temp = new corBuiltinCompareRelation(2, corLssOpSymbol, corLssOp);
    temp = new corBuiltinCompareRelation(2, corGrtOpSymbol, corGrtOp);
    temp = new corBuiltinCompareRelation(2, corLeqOpSymbol, corLeqOp);
    temp = new corBuiltinCompareRelation(2, corGeqOpSymbol, corGeqOp);
    temp = new corBuiltinCompareRelation(2, corCopyTermSymbol, corCopyTermOp);

    temp = new corBuiltinFailRelation(0, corFailSymbol);
    temp = new corBuiltinRelation(0, corCutSymbol, corCutSolver);
    temp = new corBuiltinRelation(0, corQuitSymbol, corQuitSolver);
    temp = new corBuiltinRelation(1, corGoalIdOpSymbol, corGoalIdOp);

    temp = new corBuiltinTraceRelation(-1, corExplainOnSymbol);
    temp = new corBuiltinTraceRelation(-1, corExplainOffSymbol);
    temp = new corBuiltinTraceRelation(-1, corTraceSymbol);
    temp = new corBuiltinTraceRelation(-1, corUntraceSymbol);
    temp = new corBuiltinTraceRelation(-1, corProfileOnSymbol);
    temp = new corBuiltinTraceRelation(-1, corProfileOffSymbol);

    temp = new corBuiltinDebugRelation(-1, corSetSymbol);
    temp = new corBuiltinDebugRelation(-1, corClearSymbol);
    temp = new corBuiltinDebugRelation(2, corAssignSymbol);

    temp = new corBuiltinRelation(-1, corHelpSymbol, corHelpSolver);
    temp = new corBuiltinRelation(1, corConsultSymbol, corConsultSolver);
    temp = new corBuiltinRelation(-1, corDisplaySymbol, corPrintSolver);
    temp = new corBuiltinRelation(-1, corPrintfSymbol, corPrintfSolver);
    temp = new corBuiltinRelation(-1, corPrintTupleSymbol, corTuplePrintSolver);
    temp = new corBuiltinRelation(-1, corPrintBindingSymbol, corBindingsPrintSolver);
    temp = new corBuiltinRelation(-1, corPrintEmptySymbol, corEmptyPrintSolver);
    temp = new corBuiltinRelation(-1, corStartTimerSymbol,corStartTimeSolver);
    temp = new corBuiltinRelation(-1, corDisplayTimerSymbol, corEndTimeSolver);
    temp = new corBuiltinUserTupleRelation(1, corCpuTimeSymbol, corCputimeSolver);
    temp = new corBuiltinRelation(1, corShellSymbol, corShellSolver);
    temp = new corBuiltinRelation(-1, corListRelsInDBSymbol, corRelDisplay);
    temp = new corBuiltinRelation(1, corPipeInSymbol, corpipeInSolver);
    temp = new corBuiltinRelation(2, corPipeOutSymbol, corpipeOutSolver);
    temp = new corBuiltinRelation(2, corWriteTableSymbol, corwriteTableSolver);
    temp = new corBuiltinRelation(1, corMakeIndexSymbol, coraddIndexSolver1);
    temp = new corBuiltinRelation(2, corAliasSymbol, corAliasSolver);
    temp = new corBuiltinRelation(0, corDisplayDefaultsSymbol, corDisplayDefaultsSolver);
    temp = new corBuiltinRelation(0, corResetDefaultsSymbol, corResetDefaultsSolver);

    temp = new corBuiltinRelation(1, corCreateDBSymbol, corCreateDBSolver);
    temp = new corBuiltinRelation(1, corDestroyDBSymbol, corDestroyDBSolver);
    temp = new corBuiltinRelation(-1, corCurrentDBSymbol, corCurrentDBSolver);
    temp = new corBuiltinRelation(2, corSaveDBSymbol, corSaveDBSolver);
    temp = new corBuiltinRelation(2, corRenameDBSymbol, corRenameDBSolver);
    temp = new corBuiltinRelation(1, corClearDBSymbol, corClearDBSolver);
    temp = new corBuiltinRelation(1, corListDBSymbol, corListDBSolver);
    temp = new corBuiltinRelation(2, corOpenRelInDBSymbol, corOpenRelSolver);
    temp = new corBuiltinRelation(1, corCloseRelSymbol, corCloseRelSolver);
    temp = new corBuiltinRelation(1, corClearRelSymbol, corClearRelSolver);
    temp = new corBuiltinRelation(1, corCopyRelToDBSymbol, corCopyRelSolver);
    temp = new corBuiltinRelation(1, corAddRelToDBSymbol, corAddRelSolver);
    temp = new corBuiltinRelation(1, corInsertFactSymbol, corInsertFactSolver);
    temp = new corBuiltinRelation(1, corDeleteFactSymbol, corDeleteFactSolver);
    temp = new corBuiltinRelation(1, corHistorySymbol, corHistorySolver);


    temp = new corBuiltinRelation(1, corEnterSymbol(corArrayDestructorString),
        corArrayDestructSolver);
    temp = new corBuiltinRelation(1, corEnterSymbol(corLogicalArrayConstructorString),
        corArraySolver);
    temp = new corBuiltinRelation(1, corEnterSymbol(corArrayConstructorString),
        corArraySolver);
    temp = new corBuiltinRelation(1, corEnterSymbol(corArrayLookupString),
        corArrayLookupSolver);
    temp = new corBuiltinRelation(1, corEnterSymbol(corArrayBindString),
        corArrayBindSolver);
    temp = new corBuiltinRelation(1, corEnterSymbol(corLogicalArrayBindString),
        corLogicalArrayBindSolver);

    temp = new corBuiltinRelation(1, corIsConstantSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsVarSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsListSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsFunctorSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsNumSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsStringSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsIntSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsLongSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsShortSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsFloatSymbol, ArgTypeSolver);
    temp = new corBuiltinRelation(1, corIsDoubleSymbol, ArgTypeSolver);

    temp = new corBuiltinRelation(1, corCounterSymbol, corCounterSolver);
    temp = new corBuiltinRelation(1, corResetCounterSymbol, corResetCounterSolver);
}

/*****************************************************************************/


