/*****************************************************************************/
//    CompileRule.h
/*****************************************************************************/

#ifndef _CompileRule_H_
#define _CompileRule_H_

#include "SymbolArg.h"
#include "RuleInfo.h"
#include "Rule.h"

/*****************************************************************************/

class corLiteral;
class corVarLink;
class corPredAnnotations;
class corTable;
class corSemiNaive;

/*****************************************************************************/

corVarLink* corintersect_var_lists(corVarLink *varlist1, corVarLink *varlist2);
corVarLink* corbuild_var_list(corLiteral * pred, corVarLink *list);

void corcreate_an_annotation(corPredAnnotations *&annos, corLiteral *lit,
    corVarLink *var_list);

corVarLink *corvars_between(corClause *adrule, int start, int end, corVarLink *rest,
    int *predOrders = NULL);

int coris_a_builtin(Name name);

corRuleInfo *corcreate_rule_info(corTable *F, corClause *rule);

void corcompile_nonrec_rule(corSemiNaive &sn, corClause *clause, corRuleInfo *rInfo,
    int non_ground);

void corgenerateIndexes(corSemiNaive *snrule, corPredAnnotations *&annos);
void corinitPredOrders(corSemiNaive *sn);

void initFailureBacktrack(corSemiNaive *sn, int ng_facts);

/*****************************************************************************/

#endif _CompileRule_H_

