/*****************************************************************************/
//    QFPipelinedModuleData.h
/*****************************************************************************/

#ifndef _QFPipelinedModuleData_H_
#define _QFPipelinedModuleData_H_

#include "QFModuleData.h"

#include "PipelinedExecInfo.h"
#include "Predicate.h"
#include "BacktrackInfoArray.h"

/*****************************************************************************/
//    Codependent classes

class corPipelinedExecInfo;

/*****************************************************************************/

struct pei_cache {
    corPipelinedExecInfo *pei;
    char valid;
};

/*****************************************************************************/

class corQFPipelinedModuleData : public corQFModuleData {
public:
    // Basically store the kind of information that a Scc stores
    corPredicate** pred_ptrs;        // Array of preds corresponding to the module
    int numPreds;                // Number of Preds used in the module
    int** indices;                // set of indices for each predicate
    int* maxNumVars;            // used for pre-allocation of ArrayBindEnv
    int* maxNumLiterals;        // used for pre-allocation of StackMarks and 
                                //        tuple-iterators

    int TableSetUp;

    corBacktrackInfoArray backtrackInfo;
    struct pei_cache *pei_list;

    corQFPipelinedModuleData(corTable *, corRuleInfoArray *, corParserStruct&);
    void clean_cache();
    virtual void Solve(corTable *F, corTupleIterator *) { this->F = F; }
    virtual ModuleKind kindof() { return COR_PIPELINED; }
};

/*****************************************************************************/

#endif _QFPipelinedModuleData_H_

