// *************************************************************************
//    Literal.C
// *************************************************************************

#include "Literal.h"

#include "ParserStruct.h"

// *************************************************************************
//    Creates a literal with the specifed predicate

corLiteral::corLiteral(corParserStruct& corparserStruct, Name name, int arg_count)
{
    predicate = corFindPredicate(corparserStruct, name, arg_count);
    kind = COR_REGULAR;
    pred = name;
    base_pred = 0;
    negated = 0;
    args.set_count(arg_count);
    adorn.init(arg_count);
}

corLiteral::corLiteral(corParserStruct& corparserStruct, corCArg* cname, int arg_count)
{
 Name name = cname->SymbolP();
    predicate = corFindPredicate(corparserStruct, name, arg_count);
    kind = COR_REGULAR;
    pred = name;
    base_pred = 0;
    negated = 0;
    args.set_count(arg_count);
    adorn.init(arg_count);
}

// *************************************************************************
//    Function Behaviour :: NOTE: No predicate is specified. Otherwise
//    similar to previous function.  Warning: predicate field is NULL

corLiteral::corLiteral(int arg_count)
{
    predicate = NULL;
    kind = COR_REGULAR;
    pred = NULL;
    base_pred = 0;
    negated = 0;
    args.set_count(arg_count);
    adorn.init(arg_count);
}

// *************************************************************************
corLiteral::~corLiteral()
{
}

// *************************************************************************

