/*****************************************************************************/
//    ModulePred.h
/*****************************************************************************/

#ifndef _ModulePred_H_
#define _ModulePred_H_

#include "PredAnnotations.h"
#include "ArgList.h"

/*****************************************************************************/

class corPredicate;

/*****************************************************************************/

struct corAnnoStruct {
public:
    corPredAnnotations *anno;
    int num_vars;
    struct corAnnoStruct *next;
    corAnnoStruct(corPredAnnotations *a, int vars, struct corAnnoStruct *nxt) {
        anno = a;
        num_vars = vars;
        next = nxt;
    }
};

/*****************************************************************************/

enum PredKind {
    QueryPredKind,
    MagicQueryPredKind,
    LocalPredKind,
    ExternalPredKind
};

/*****************************************************************************/

class corModulePred {
public:
    corPredicate *pred;
    PredKind kind;
    int check_subsum;
    int disk_rel;
    corArgList *schema_def;
    int offset;
    struct corAnnoStruct *index_annos;
    struct corAnnoStruct *aggsel_annos;
    struct corAnnoStruct *prior_annos;
    struct corModulePred *next;

    corModulePred(corPredicate *p) {
        pred = p;
        next = NULL;
        schema_def = NULL; 
        index_annos = NULL;
        aggsel_annos = NULL;
        prior_annos = NULL;
    }
};

typedef class corModulePred corModulePred;

/*****************************************************************************/

#endif _ModulePred_H_

