/*****************************************************************************/
//    PredAnnotations.C
/*****************************************************************************/

#include "PredAnnotations.h"

#include "Unparse.h"

/*****************************************************************************/
corPredAnnotations::corPredAnnotations(corSymbol *pred1, struct corPredAnnotations *next1)
{
    pred = pred1;
    _next = next1;
    op_arg.init();
    arglist1 = arglist2 = NULL;
}

/*****************************************************************************/
/*
    if "adorned" is not set, the field "adorn" is printed in
    parentheses instead of with an "_"
*/

void corPredAnnotations::print(FILE *file, int adorned)
{

    if (adorned) {
        corfprint_pred_name(file, corSymbolString(pred), adorn);
    }
    else {
        corfprint_pred_name(file, corSymbolString(pred), (corBitVector *) NULL);
        if (adorn) {
            fputs("[",file);
            for (int i = 0; i < adorn->len(); i++)
                fputs((adorn->test(i) ? "b" : "f"), file);
            fputs("]",file);
        }
    }

    if (arglist1) {
        fputs("(",file);
        arglist1->print(NULL,file);
        fputs(")",file);
    }

    if (arglist2) {
        fputs("(",file);
        arglist2->print(NULL,file);
        fputs(")",file);
    }

    if ((!op_arg.IsEmpty()) && (!op_arg.equals(0))) {
        op_arg.print(NULL,file);
    }
}

/*****************************************************************************/

