/*****************************************************************************/
//    Predicate.C
/*****************************************************************************/

#include "Predicate.h"

#include "ParserStruct.h"

/*****************************************************************************/
//NOTE: This should be the constructor for Predicate -- PRAVEEN

corPredicate *corAllocPredicate(corParserStruct& corparserStruct, Name name, int arity)
{
    corPredicate *pred = new corPredicate;

    pred->name = name;
    pred->arity = arity;
    pred->clauses = NULL;
    pred->clause_tail = &pred->clauses;
    pred->work = NULL;
    pred->allprednext = corparserStruct.AllPredicates;
    pred->ext_magic = 0;  // added by Ken
    corparserStruct.AllPredicates = pred;
    return pred;
}


/*****************************************************************************/
//    Adds a rule (a.k.a. clause) to the list of rules defining a predicate.

void corAddClauseToPredicate(corPredicate *predicate, corClause *clause)
{
    clause->pnext = *predicate->clause_tail;
    *predicate->clause_tail = clause;
    predicate->clause_tail = &clause->pnext;
}

/*****************************************************************************/
//    Used to determine if the predicate is a magic predicate.  This may not be
//    the right way to do it. Perhaps a subclass called MagicPredicate should
//    be defined --- PS

int coris_magic(Name name)
{
    char *str_name = name->string();
    int len = strlen(str_name);
    if (len > 1) {
        return str_name[0] == 'm' && str_name[1] == '_';
    }
    else return 0;
}

/*****************************************************************************/
int coris_mp_done(Name name)
{
    char *str_name = name->string();
    int len = strlen(str_name);

    if (len > 4) {
        return (str_name[0] == 'd' && str_name[1] == 'o' && str_name[2] == 'n'
            && str_name[3] == 'e' && str_name[4] == '_') ;
    }
    else return 0;
}

/*****************************************************************************/
int coris_supp(Name name)
{
    char *str_name = name->string();
    int len = strlen(str_name);

    if (len > 3) {
        return (str_name[0] == 's' && str_name[1] == 'u' &&
            str_name[2] == 'p' && str_name[3] == '_') ;
    }
    else return 0;
}

/*****************************************************************************/

