// *************************************************************************
//    RuleInfoArray.C
// *************************************************************************

#include "RuleInfoArray.h"

// *************************************************************************
corRuleInfoArray::corRuleInfoArray()
{
    array_size = 0;
    numRules = 0 ;
    rInfoPtrs = NULL;
}

// *************************************************************************
corRuleInfoArray::~corRuleInfoArray()
{
    for (int i=0; i<numRules; i++)
        delete rInfoPtrs[i];
    
    delete [] rInfoPtrs;
}

// *************************************************************************
void corRuleInfoArray::AddRule(corRuleInfo *rInfo)
{
        // Check if array needs expansion
    if (numRules == array_size){

        if (array_size == 0){
            array_size = MIN_RIARRAY_SIZE;
            rInfoPtrs = new (corRuleInfo *)[array_size];
        } else {
                // Out of space - so double it
            corRuleInfo **temp = rInfoPtrs;
            array_size += array_size;
            rInfoPtrs = new (corRuleInfo *)[array_size];
            
            for (int i=0; i < numRules; i++)
                rInfoPtrs[i] = temp[i] ;

            delete [] temp;
        }
    }

    rInfoPtrs[numRules++] = rInfo;
}

// *************************************************************************
void corRuleInfoArray::printon(FILE *outf)
{
    for (int i=0; i< numRules; i++)
        fprintf(outf, "%s\n", rInfoPtrs[i]->pInfo.rule) ;
}

// *************************************************************************

