// *************************************************************************
//    SccEnv.C
// *************************************************************************

#include "SccEnv.h"

#include "SccInfo.h"

// *************************************************************************
corSccEnv::corSccEnv(corSccInfo *parent)
{
    int i;

    parent_scc = parent;
    numSNRules = parent->numSNRules;
    if (!parent->module->module_info.SaveModule) 
        rm_Arr = new corRMarkArray(2*parent->numPreds) ;
    else
        rm_Arr = new corRMarkArray(2*(parent->numPreds+parent->num_lowerPreds)) ;

    snrule_envs = new corRuleEnv *[parent->numSNRules];
    for (i = 0; i < parent->numSNRules; i++)
        snrule_envs[i] = new corRuleEnv(&(parent->sn_rules[i]));
}

// *************************************************************************
corSccEnv::~corSccEnv()
{
    if (rm_Arr) delete rm_Arr;
    for (int i = 0; i < parent_scc->numSNRules; i++)
        delete snrule_envs[i];
    delete [] snrule_envs;
}

// *************************************************************************
