/*****************************************************************************/
//    BufferGroup.C
/*****************************************************************************/

#ifdef WITH_PERSISTENCE

#include "Globals.h"
#include "CoralError.h"
#include "SMUtil.h"
#include "sm_client.h"
#include "Config.h"
#include "Schema.h"
#include "IndexStruct.h"
#include "BPlusTreeIndex.h"
#include "FileDescStruct.h"
#include "BufferGroup.h"
#include "Transaction.h"
#include "Catalog.h"
#include "StorageManager.h"

/*****************************************************************************/
void corBufferGroup::close() 
{
  if (!SM_initialized) return;

  if (BUFGROUP_IS_INVALID(bufGroup)) return;
  int e = sm_CloseBufferGroup(bufGroup);
  ErrorCheck(e, "sm_CloseBufferGroup");
  INVALIDATE_BUFGROUP(bufGroup);
}

/*****************************************************************************/

#endif WITH_PERSISTENCE

