/*****************************************************************************/
//    Schema.C
/*****************************************************************************/

#ifdef WITH_PERSISTENCE


#include "Globals.h"
#include "CoralError.h"
#include "SMUtil.h"
#include "sm_client.h"
#include "Config.h"
#include "Schema.h"
#include "IndexStruct.h"
#include "BPlusTreeIndex.h"
#include "FileDescStruct.h"
#include "BufferGroup.h"
#include "Transaction.h"
#include "Catalog.h"
#include "StorageManager.h"

/*****************************************************************************/
corSchema::corSchema(corArgList &arglist, int& error)
{
    int i = 0;
    FOR_EACH_ARG(arg, arglist) {
        if (strcmp(corSymbolString(*arg), "int")) {
            if (strcmp(corSymbolString(*arg), "double")) {
                if (strcmp(corSymbolString(*arg), "string")) {
                    error = COR_BAD_SCHEMA;
                    return;
                }
                else
                    types[i] = COR_STRING_DBTYPE;
            }
            else
                types[i] = COR_DOUBLE_DBTYPE;
        }
        else
            types[i] = COR_INT_DBTYPE;

        i++;
    } END_EACH_ARG

    arity = i;
}

/*****************************************************************************/
void corSchema::operator=(corSchema& schema2)
{
    for (int i = 0; i < COR_MAX_ARGLIST_SIZE; i++ )
        types[i] = schema2.types[i];
    arity = schema2.arity;
}

/*****************************************************************************/
void corSchema::printon(FILE *outf)
{
    fprintf(outf, "(");
    for (int i = 0; i < arity; i++) {
        switch (types[i]) {
        case COR_INT_DBTYPE:
            fprintf(outf, "int");
            break;
        case COR_DOUBLE_DBTYPE:
            fprintf(outf, "double");
            break;
        case COR_STRING_DBTYPE:
            fprintf(outf, "string");
            break;
        default:
            break;
        }

        if (i < arity - 1) fprintf(outf, ", ");
    }
    fprintf(outf, ")");
}

/*****************************************************************************/

#endif WITH_PERSISTENCE

