
//**************************************************************************
//    User.C
//
//    The User Class - Contains all the information about a user and
//    their current envirornment.
//
//**************************************************************************

#include "User.h"

#include "CoralInit.h"
#include "Database.h"
#include "Assert.h"
          
//**************************************************************************
// User Constructor -
//    Clears everything, and sets all envirornment values to the defaults.
//
//**************************************************************************
corUser::corUser(FILE *in, FILE *out, FILE *err)
            :corexEnv(&cordeflt_exEnv,in,out,err)
{
   *login_name = *password = '\0';
    user_id = 0;

      // Set current database to the default
    corCurDB = corlookupDB(corEnterSymbol(COR_DEFAULT_DB));

    num_answers  = DEFLT_ANSWRS_PER_QRY;

    explain_sock = (CoralSock *) NULL;
}

//**************************************************************************
// User Destructor -
//    Deletes the socket to explain, if the user has one.
//
//**************************************************************************
corUser::~corUser()
{
      // Close up connection to explain (if any)
    if (explain_sock)
        delete explain_sock;
}

//**************************************************************************
// whoami() -
//    A simple function to print the user's name on the file pointer given.
//
//**************************************************************************
void corUser::whoami(FILE *fp)
{
    fputs(login_name,fp);
    fputs("\n",fp);
}

//**************************************************************************
// yield() -
//    Set flag(s) to indicate a yield should be performed at the end of
//    this command.
//
//**************************************************************************
void corUser::yield()
{
      // Talking about this user's exEnv, not global.

    corexEnv.C_interrupt_raised = 2; // informs parser odd things are occuring
    corexEnv.yield = 1;              // (in this case, yielding)
}

//**************************************************************************
