
//**************************************************************************
//    User.h
//
//    The User Class - Contains all the information about a user and
//    their current envirornment.
//
//**************************************************************************

#ifndef _User_H_
#define _User_H_

#include "CoralSock.h"
#include "DatabaseStruct.h"
#include "ExecutionEnv.h"
          
//**************************************************************************

                                // The default number of answers to
                                // return before suspending
#define  DEFLT_ANSWRS_PER_QRY     20

//**************************************************************************

class corUser {

friend class corConnection;

public:
  char   login_name[9];        // The login name of the user
  char   password[9];          // Their password (clear text)

  int    user_id;              // A numerical id  (this session only)

  corExecutionEnv    corexEnv;       // The execution environrment for this user

  corDatabaseStruct *corCurDB;       // The current database of this user

  int      num_answers;        // The number of answers to return before
                               // suspending a query.


  CoralSock      *explain_sock;   // The connection back to user's explain

  corUser(FILE *in, FILE *out, FILE *err);
 ~corUser();

    // Tell who you are
  void whoami(FILE *fp);

    // Set flag(s) to indicate a yield should be performed at the end of
    // this command
  void yield();
};

//**************************************************************************

#endif  // _User_H_
