/*****************************************************************************/
//	BasePreds.C
/*****************************************************************************/

#include "BasePreds.h"

#include "Rule.h"
#include "Literal.h"

/*****************************************************************************/
void mark_basepreds(struct corcollection *rules)
{
	int p;

	FOR_EACH_RULE(rule, rules) {
		for (p=0; p < rule->num_preds; ++p) {
			rule->preds[p]->base_pred =
				HashNone(corSymbolLookup(rules->tab, rule->preds[p]->pred)->arg);
		}
	} END_EACH_RULE
}

/*****************************************************************************/
void mark_all_as_basepreds(struct corcollection *rules)
{
	int p;

	FOR_EACH_RULE(rule, rules) {
		for (p=0; p < rule->num_preds; ++p) {
			rule->preds[p]->base_pred = 1;
		}
	} END_EACH_RULE
}

/*****************************************************************************/
void mark_all_as_derived(struct corcollection *rules)
{
	int p;

	FOR_EACH_RULE(rule, rules) {
		for (p=0; p < rule->num_preds; ++p) {
			rule->preds[p]->base_pred = 0;
		}
	} END_EACH_RULE
}

/*****************************************************************************/

