/*****************************************************************************/
//	TermList.h
/*****************************************************************************/

#ifndef _TermList_H_
#define _TermList_H_

#include "ArgList.h"
#include "VarArg.h"
#include "FuncArg.h"
#include "Literal.h"

/*****************************************************************************/
// Structure used to keep track of function terms that have been replaced
// by dummy variables in order to generate rules in Extended Datalog form.

typedef struct TermList TermList;

struct TermList {
	corArgList* arg_list;				// ArgList that held the term
	int arg_pos;					// Position of term within ArgList
	corVarArg* var_arg;				// Dummy VarArg used
	corFuncArg* func_arg;				// Original FuncArg replaced
	corLiteral* dummy_pred;			// Dummy predicate introduced
	struct TermList* similar;		// Pointer to an identical TermList struct
									// if such exists
	struct TermList *next;

	TermList();
	TermList(corArgList *alist, int apos);
	void set_vararg(corVarArg * varg)		{ var_arg = varg; }
	void set_funcarg(corFuncArg * farg)	{ func_arg = farg; }
	void set_similar(TermList *t)		{ similar = t; }
};

/*****************************************************************************/

#endif _TermList_H_

