/*****************************************************************************/
/*    Kind.h   */
/*****************************************************************************/

#ifndef _Kind_H_
#define _Kind_H_

/*****************************************************************************/

typedef enum type_of_arg {

    INVALID_T = 0,

    CHAR_T,
    FLOAT_T,
    DOUBLE_T,
    VOID_T, 

    STRING_T,
    ARG_T,

        /* The values matter for these next ones (using masks) */
        /* The 4-bit value can be interpreted as (from msb to lsb):
            int            Always one for all int types     
            short          Indicates this int is short
            long           Indicates this int is long
            unsigned       Indicates this int is unsigned
        */
    INT_T = 8,                /* 1000 */
    SHORT_INT = 9,
    LONG_INT = 10,
    UNSIGNED_INT = 12,
    UNSIGNED_SHORT_INT = 13,
    UNSIGNED_LONG_INT = 14,


        /* Currently not implemented ? */
        /* Note we skip 15, since the int bit would be set */
    CLASS_T = 16,
    STRUCT_T = 17

} type_of_arg;

    /* To make/check for the above integer qualifiers */
#define  INT_MSK          8
#define  SHORT_MSK        1
#define  LONG_MSK         2
#define  UNSIGNED_MSK     4
#define  SIGNED_MSK      11      /* _and_ with this mask, not _or_ */ 

/*****************************************************************************/

/*
typedef enum {

    TYPE_CHAR, TYPE_DOUBLE, TYPE_FLOAT, TYPE_INT,
    TYPE_LONG, TYPE_SHORT, TYPE_STRING, TYPE_UNSIGNED,
    TYPE_FILENAME,
    TYPE_NONE
} type_name;
*/

/*****************************************************************************/

typedef struct {

    type_of_arg value; 
    int pointer;    /* whether it is a pointer or not */
    char *name;    /* the type without the -ve sign and 
             * without any * signs
             */

    char *type;      /* used for typecasting when 
               * the appropriate argument is 
               * being extracted from the 
               * input tuple *
               */

    char *argname;      /* the name of the variable associted
               * this type
               */

    int init_pointer; /* for arguments (& return types), it 
               * indicates whether the pointer
               * should be allocated memory or not
               */ 

    char *make;      /*
               * used for determining which fn  
               * to call in order to extract the 
               * value out of input tuple arglist
               */

    char *_typedef;      /* not used */
    int opt_neg_sign; /* whether the optional -ve sign 
               * was present or not
               */
} kind;

/*****************************************************************************/

#endif _Kind_H_

